import QtQuick 1.0
import com.nokia.meego 1.0

import "." as MyComponents


Page {
//   orientationLock: PageOrientation.LockLandscape
//     orientationLock: PageOrientation.LockPortrait
    

    function setQMLData(showHomeNetwork, autoreset, resetday, usedifference, difference){
	rbHome.checked = showHomeNetwork
	if(rbHome.checked == false){
	    rbRoaming.checked = true
// 	    settingsHome.visible = false
// 	    settingsRoaming.visible = true	    
	}
	cbautoreset.checked = autoreset
	txtresetday.text = resetday
	cbdifference.checked = usedifference
	txtdifference.text = difference
	console.log("setQMLData:", showHomeNetwork, autoreset, resetday, usedifference, difference)
    }
        
    
    function setHomeData(gprs_home_tx_bytes, gprs_home_rx_bytes, gprs_home_last_reset){
	homeupload.text = gprs_home_tx_bytes
	homedownload.text = gprs_home_rx_bytes
	homeresetdate.text = "Last reset: " + gprs_home_last_reset	
    }
    
    
    function setRoamingData(gprs_roaming_tx_bytes, gprs_roaming_rx_bytes, gprs_roaming_last_reset){
	roamingupload.text = gprs_roaming_tx_bytes
	roamingdownload.text = gprs_roaming_rx_bytes
	roamingresetdate.text = "Last reset: " + gprs_roaming_last_reset
    }
    
    
    
    
    
    //We want to tell Python whenever our display orientation changes
    //This is done with the signal "onWidthChanged".
    //This how ever is not called at start up, because of that we also use a sigle shot timer
    onWidthChanged: {
      displayOrientationChanged()
    }

    Timer {
	interval: 1; running: true; repeat: false
	onTriggered: {
	  displayOrientationChanged()    
	}
    }
    
    //Tell Python that the display orientation changed
    function displayOrientationChanged(){
	if (width > 600) { // landscape			
	    console.log("[QML INFO] Landscape")
	} 
	else { // portrait		
	    console.log("[QML INFO] Portrait")
	}
	
	spacer1.width = width - 20
	spacer2.width = width - 20 
// 	spacer3.width = width - 20	
    }
    
    
//*******************************************************
    
    
    id: mainPage
    tools: toolbar

//     anchors.margins: 10
    
    
    Item{
	id: page
	width: parent.width   
	  
	  
	  
	  
	Item {
	  id: titlebar
	    width: parent.width
	    height: 70

	    Rectangle {
		anchors.fill: parent
		color: "orange";
	    }
	   
	    Label {
		anchors {
		    left: parent.left
		    leftMargin: 10
		    verticalCenter: parent.verticalCenter
		    top: parent.top
		    topMargin: 20
		}
		font.bold: true;
		font.pixelSize: 32
		color: "White"

		text: "GPRS Data Usage"
	    }
	}

		
	  
	Flickable {	  
	    id: flickable
	    width: parent.width
	    anchors.top: titlebar.bottom
	    height: mainPage.height - titlebar.height
	    contentWidth: parent.width
	    contentHeight: col.height + 20	    
	    clip: true
	    
	    Column{
		id: col
		anchors {
		    left: parent.left
		    leftMargin: 10
		    rightMargin: 10
		    topMargin: 10
		    top: parent.top
		}
		
		
		
	    	 
		Column { ///////////////////////////////////////////////////////////////////// NETWORKS
		    id:networks
		    width: parent.width
		    spacing: 20
			  
			  
		    Row{		  		  
			Text{
			    id: networkheader
			    text: "General"
			    font.bold: true;
			    font.pixelSize: 26
			    color: "gray"
			    
			}
		    }
		
		    Row{
			id:home
			anchors.top: networkheader.bottom
// 			spacing: 10
			
			RadioButton {
			    id: rbHome
			    checked: true
			    onClicked: {
				rbRoaming.checked = false
// 				settingsHome.visible = true
// 				settingsRoaming.visible = false
				qml_to_python.getQMLData(rbHome.checked, cbautoreset.checked, txtresetday.text, cbdifference.checked, txtdifference.text) 
			    }		
			}		    
			Text{	
			    text: "Shows Home Network"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
			    height: rbHome.height
			}		  
		    }
		    
		    
		    
		    Row{
			id:roaming
			anchors.top: networkheader.bottom
// 			spacing: 10
			
			RadioButton {
			    id: rbRoaming
			    onClicked: {
				rbHome.checked = false
// 				settingsHome.visible = false
// 				settingsRoaming.visible = true
				qml_to_python.getQMLData(rbHome.checked, cbautoreset.checked, txtresetday.text, cbdifference.checked, txtdifference.text) 
			    }		
			}		    
			Text{	
			    text: "Show Roaming Network"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
			    height: rbRoaming.height
			}		  
		    }	
		    
		    
		    
		    Row{
			id:autoreset
// 			spacing: 10
// 			visible: false //not yet implemented
			
			CheckBox {
			    id: cbautoreset
			    checked: false
// 			    enabled: false
			    onClicked: {			     
				qml_to_python.getQMLData(rbHome.checked, cbautoreset.checked, txtresetday.text, cbdifference.checked, txtdifference.text) 
			    }
			}	
			

			Text{	
			    text: "Autoreset every <br>month at day "
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
			    height: cbautoreset.height	
			}	
			
			Rectangle{
			    height: 1
			    width: 10
			    color: "transparent"
			}	
		    
			TextField {         
			    id: txtresetday
			    validator: IntValidator{bottom: 1; top: 31;}
			    inputMethodHints: Qt.ImhDigitsOnly | Qt.ImhNoPredictiveText
			    height: 50
			    width: 90			    
			    onTextChanged: {			     
				text = text * 1
				if(text == 0)text = 1
				qml_to_python.getQMLData(rbHome.checked, cbautoreset.checked, txtresetday.text, cbdifference.checked, txtdifference.text) 
			    }
			}	
			
// 			    Text{	
// 				text: " of every month"
// 				font.bold: true;
// 				font.pixelSize: 22
// 				verticalAlignment: Text.AlignVCenter
// 				height: cbautoreset.height	
// 				wrapMode: Text.WordWrap
// 
// 			    }

		    }
		    
		    
		    
		    Row{
			id:leftdata
// 			spacing: 10
			
			CheckBox {
			    id: cbdifference
			    checked: false
// 			    enabled: false
			    onClicked: {
// 				if(cbdifference.checked)txtdifference.enabled = true
// 				else txtdifference.enabled = true
				qml_to_python.getQMLData(rbHome.checked, cbautoreset.checked, cbautoreset.checked, cbdifference.checked, txtdifference.text) 
			    }
			}	
			
			Text{	
			    text: "Show remaining data to "
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
			    height: txtdifference.height			  
			}	
			 
			TextField {         
			    id: txtdifference
// 			    enabled: false
			    validator: IntValidator{bottom: 0; top: 10000;}
			    inputMethodHints: Qt.ImhDigitsOnly | Qt.ImhNoPredictiveText
			    height: 50
			    width: 100			    
			    onTextChanged: {			     
				text = text * 1
				qml_to_python.getQMLData(rbHome.checked, cbautoreset.checked, cbautoreset.checked, cbdifference.checked, txtdifference.text) 				
			    }
			}			
			
			Text{	
			    text: " MB"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
			    height: txtdifference.height			  
			}
		    }
		    
		    Row{
		      
			Text{	
			    text: "Note: You can set a data limit alert in\nSettings > Phone > Counter!"
			    font.bold: true;
			    font.pixelSize: 22	
// 			    color: red
// 			    width: 460
// 			    width: parent.width
// 			    wrapMode: Text.WordWrap
			}
			
		    }
		    
		    Rectangle{
			id: spacer1
			height: 1
			width: parent.width
			color: "gray"
		    }		    
		}
		
		
		
		
		
		Column{ ///////////////////////////////////////////////////////////////////// HOME
		    id:settingsHome
		    spacing: 10
		    anchors.topMargin: 20
		    
		    
		    
		    Rectangle{
			height: 10
			width: parent.width
			color: "transparent"
		    }		
		    
		    
		    Text{
			id: homenetworkheader
			text: "Data of Home Network"
			font.bold: true;
			font.pixelSize: 26
			color: "gray"
		    }
		    
		    Row{
			id: homenetworkupload
			spacing: 10
			Text{			
			    text: "Upload:"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
// 			    height: 50
			    width: 120
			}
			  
// 			TextField {         
// 			    id: homeupload
// 			    validator: IntValidator{bottom: 0; top: 1000;}
// 			    inputMethodHints: Qt.ImhDigitsOnly | Qt.ImhNoPredictiveText
// 			    height: 50
// 			    width: 90
// 			    onTextChanged: {
// 				qml_to_python.getHomeData(homeupload.text, homedownload.text, cbhomealarm.checked, homealarm.text, false)
// 			    }
// 			}
			
			Text {         
			    id: homeupload
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
			    horizontalAlignment: Text.AlignRight
// 			    height: 50
			    width: 90
			}
			
			Text{			
			    text: "MB"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
// 			    height: 50
			    width: 120
			}
		    }
		    
		    Row{
			id: homenetworkdownload
			spacing: 10
			
			Text{			
			    text: "Download:"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
// 			    height: 50
			    width: 120
			}
			
// 			TextField {         
// 			    id: homedownload
// 			    validator: IntValidator{bottom: 0; top: 1000;}
// 			    inputMethodHints: Qt.ImhDigitsOnly | Qt.ImhNoPredictiveText
// 			    height: 50
// 			    width: 90
// 			    onTextChanged: {
// 				qml_to_python.getHomeData(homeupload.text, homedownload.text, cbhomealarm.checked, homealarm.text, false)
// 			    }
// 			}
			  
			Text {         
			    id: homedownload
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
			    horizontalAlignment: Text.AlignRight
// 			    height: 50
			    width: 90
			}
			
			Text{			
			    text: "MB"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
// 			    height: 50
			    width: 120
			}
		    }
		    
		    Row{
			spacing: 10
			Button {
                            width: 150
                            text: "Change"
			    onClicked: {
				changedialogue.network = "Home";				
				changedialogue.open();
			    }
                        }                       
		    }	 
		    
		    Row{
			spacing: 10
			Button {
                            id: homereset
                            width: 150
                            text: "Reset"
			    onClicked: {
// 				qml_to_python.getHomeData(0, 0, cbhomealarm.checked, homealarm.text, true)
				qml_to_python.getHomeData(0, 0)
			    }
                        }
                        
                        Text{	
			    id: homeresetdate
			    text: "Last reset: 12.12.2011"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
			    height: homereset.height
			}                        
		    }	    
		    
		    
// 		    Row{
// // 			id:homealarm
// // 			spacing: 10
// 			visible: false //Not yet implemented
// 			
// 			CheckBox {
// 			    id: cbhomealarm
// 			    checked: false
// // 			    enabled: false
// 			    onClicked: {
// 				qml_to_python.getHomeData(homeupload.text, homedownload.text, cbhomealarm.checked, homealarm.text, false)
// 			    }
// 			}	
// 			
// 			Text{	
// 			    text: "Show warning when data reaches "
// 			    font.bold: true;
// 			    font.pixelSize: 22
// 			    verticalAlignment: Text.AlignVCenter
// 			    height: txtdifference.height			  
// 			}	
// 			 
// 			TextField {         
// 			    id: homealarm
// // 			    enabled: false
// 			    validator: IntValidator{bottom: 0; top: 1000;}
// 			    inputMethodHints: Qt.ImhDigitsOnly | Qt.ImhNoPredictiveText
// 			    height: 50
// 			    width: 90			    
// 			    onTextChanged: {			     
// 				qml_to_python.getHomeData(homeupload.text, homedownload.text, cbhomealarm.checked, homealarm.text, false)
// 			    }
// 			}			
// 			
// 			Text{	
// 			    text: " MB"
// 			    font.bold: true;
// 			    font.pixelSize: 22
// 			    verticalAlignment: Text.AlignVCenter
// 			    height: txtdifference.height			  
// 			}
// 		    }
		    
		    
		    
		    Rectangle{
			id: spacer2
			height: 1
			width: parent.width
			color: "gray"
		    }		
		}
		
		
		
		
		
		
		
		
		
		Column{ ///////////////////////////////////////////////////////////////////// ROAMING
		    id:settingsRoaming
		    spacing: 10
		    anchors.topMargin: 20
// 		    visible: false
		    
		    
		    Rectangle{
			height: 10
			width: parent.width
			color: "transparent"
		    }		
		    
		    Text{
			id: roamingnetworkheader
			text: "Data of Roaming Network"
			font.bold: true;
			font.pixelSize: 26
			color: "gray"
		    }
		    
		    Row{
			id: roamingnetworkupload
			spacing: 10
			
			Text{			
			    text: "Upload:"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
// 			    height: 50
			    width: 120
			}
						  
// 			TextField {         
// 			    id: roamingupload
// 			    validator: IntValidator{bottom: 0; top: 1000;}
// 			    inputMethodHints: Qt.ImhDigitsOnly | Qt.ImhNoPredictiveText
// 			    height: 50
// 			    width: 90
// 			    onTextChanged: {
// 				qml_to_python.getRoamingData(roamingupload.text, roamingdownload.text, false)
// 			    }
// 			} 
			
			Text {         
			    id: roamingupload
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
			    horizontalAlignment: Text.AlignRight
// 			    height: 50
			    width: 90
			}
			
			Text{			
			    text: "MB"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
// 			    height: 50
			    width: 120
			}
		    }
		    
		    Row{
			id: roamingnetworkdownload
			spacing: 10
			
			Text{			
			    text: "Download:"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
// 			    height: 50
			    width: 120
			} 
			
// 			TextField {         
// 			    id: roamingdownload
// 			    validator: IntValidator{bottom: 0; top: 1000;}
// 			    inputMethodHints: Qt.ImhDigitsOnly | Qt.ImhNoPredictiveText
// 			    height: 50
// 			    width: 90
// 			    onTextChanged: {
// 				qml_to_python.getRoamingData(roamingupload.text, roamingdownload.text, false)
// 			    }
// 			}
			  
			Text {         
			    id: roamingdownload
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
			    horizontalAlignment: Text.AlignRight
// 			    height: 50
			    width: 90
			}
			
			Text{			
			    text: "MB"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
// 			    height: 50
			    width: 120
			}
		    }
		    		    
		    Row{
			spacing: 10
			Button {
                            width: 150
                            text: "Change"
			    onClicked: {
				changedialogue.network = "Roaming";
				changedialogue.open();
			    }
                        }                       
		    }	 
		    
		    Row{
			spacing: 10
			Button {
                            id: roamingreset
                            width: 150
                            text: "Reset"
			    onClicked: {
				qml_to_python.getRoamingData(0, 0)
			    }
                        }
                        
                        Text{		
			    id: roamingresetdate	
			    text: "Last reset: ???"
			    font.bold: true;
			    font.pixelSize: 22
			    verticalAlignment: Text.AlignVCenter
			    height: homereset.height
			}                        
		    }	    
		    
// 		    Rectangle{
// 			id: spacer3
// 			height: 1
// 			width: parent.width
// 			color: "gray"
// 		    }
		}
		
		
		
		
		
		
		
// 		Column{ ///////////////////////////////////////////////////////////////////// GENERAL
// 		    id:settingsGeneral
// 		    spacing: 10
// 		    anchors.topMargin: 20
		    
// 		    Rectangle{
// 			height: 10
// 			width: parent.width
// 			color: "transparent"
// 		    }		
// 		    
// 		    Text{
// 			id: general
// 			text: "General"
// 			font.bold: true;
// 			font.pixelSize: 26
// 			color: "gray"
// 		    }
// 		    
// 		    
// 		    
// 		}
		
		
	    }
	}

    }

    
    
    

//*******************************************************



    ToolBarLayout {
	id: toolbar
	
	ToolButtonRow { 	    
	}	      
	    
	ToolIcon {
	    iconId: "toolbar-view-menu" ;
	    onClicked: myMenu.open();
	}
    }    
   
    

//*******************************************************

    QueryDialog {
        id: changedialogue
        icon: "/opt/gprs-data-usage/images/icon2.svg"
        titleText: "Change data of the " + network + " Network?"
        message: "Please make sure you do not have an active GPRS connection. Also, you should reboot your device immediately after setting the new data values. Else they will automatically get reset to the old values!"

	acceptButtonText: "Continue"
	rejectButtonText: "Cancel"
	
	property string network: ""
	
	onAccepted:{
	    console.log("continue")
	    if(network == "Home"){	      
		networkPage.updateData(network, homeupload.text, homedownload.text)
	    }
	    else{
		networkPage.updateData(network, roamingupload.text, roamingdownload.text)
	    }
	    pageStack.push(networkPage)
	}
	
	onRejected:{
	    console.log("cancel")
	}
    }
//*******************************************************

    

    MyComponents.NetworkPage {
        id: networkPage
    }

}
