#!/usr/bin/python

##############################################################################################
# Copyright (c) by George Ruinelli 
# License: 	GPL3
# ToDo:		Add autoreset option
#		Add notification messages
#		Add color for data left
##############################################################################################


import sys
from PySide.QtCore import *
from PySide.QtGui import *
from PySide.QtDeclarative import *
from PySide.QtGui import QDesktopServices as QDS

#import math
import platform
import time
import datetime
import os
import string
import ConfigParser
import gconf

print ""


# Read out all gconf values in terminal:
# gconftool-2  --dump /
#Set Value: gconftool-2 -s /cellui/settings/datacounter/general/gprs_home_last_reset --type string "21.1.2012.1327151628"
#	    gconftool-2 -s /cellui/settings/datacounter/transfer/gprs_home_rx_bytes --type string "15000000"
#Get Value: gconftool-2 -g /cellui/settings/datacounter/transfer/gprs_home_rx_bytes
#Get Value: gconftool-2 -g /cellui/settings/datacounter/general/gprs_home_last_reset


# Note:
# Nokia for some reason uses MB = 1000 * 1000 * Bytes


####################################################################################################
class Configuration():
    def __init__(self):
	#data.config_path = os.path.join(QDS.storageLocation(QDS.DataLocation), "gprs-data-usage")
	data.config_path = "/home/user/.local/share/data/gprs-data-usage/"
	data.config_file = data.config_path + "/" + data.config_file
  
	  
    def Load(self):
	print "Loading configuration from:", data.config_file
	self.ConfigParser = ConfigParser.SafeConfigParser()
	try:
	    self.ConfigParser.read(data.config_file)
	except: #use default config
	    print "Configuration file "+ data.config_file + " not existing or not compatible"

	try:
	    self.ConfigParser.add_section('main')
	except:
	    pass

	try:	    
	  #data.config_gprs_home_rx_bytes = self.ConfigParser.getint("main", "gprs_home_rx_bytes")  
	  #data.config_gprs_home_tx_bytes = self.ConfigParser.getint("main", "gprs_home_tx_bytes") 
	  #data.config_gprs_roaming_rx_bytes = self.ConfigParser.getint("main", "gprs_roaming_rx_bytes")  
	  #data.config_gprs_roaming_tx_bytes = self.ConfigParser.getint("main", "gprs_roaming_tx_bytes")  
	  data.showHomeNetwork = self.ConfigParser.getboolean("main", "showHomeNetwork")  
	  data.useautoreset = self.ConfigParser.getboolean("main", "useautoreset")  
	  data.resetday = self.ConfigParser.getint("main", "resetday")  
	  data.usedifference = self.ConfigParser.getboolean("main", "usedifference")  
	  data.difference = self.ConfigParser.getint("main", "difference")  
	  print "Configuration loaded"  
	except:
	    print "Error loading configuration, using default value"

    
    
    
    
    
    def Write(self):
	print "Write configuration to:", data.config_file  
	
	#self.ConfigParser.add_section('main')
		  
	self.ConfigParser.set('main', 'gprs_home_rx_bytes', "-1")  #do this so icon gets updated on closure
	self.ConfigParser.set('main', 'gprs_home_tx_bytes', "-1")
	self.ConfigParser.set('main', 'gprs_roaming_rx_bytes', "-1")
	self.ConfigParser.set('main', 'gprs_roaming_tx_bytes', "-1")
	self.ConfigParser.set('main', 'showHomeNetwork', str(data.showHomeNetwork))
	self.ConfigParser.set('main', 'useautoreset', str(data.useautoreset))
	self.ConfigParser.set('main', 'resetday', str(data.resetday))
	self.ConfigParser.set('main', 'usedifference', str(data.usedifference))
	self.ConfigParser.set('main', 'difference', str(data.difference))

	try:
	    os.makedirs(data.config_path)
	except:
	  pass

	try:
	    handle = open(data.config_file, 'w')
	    self.ConfigParser.write(handle)
	    handle.close()
	    print "Configuration saved"
	except:
	    print "Failed to write configuration file!"


	    
	    
################################################################################################  



class Data():
  Valid_Device = True
    
  root = ""
  
  config_path = ""
  config_file = "config.conf"
  
  desktop_file = "/home/user/.local/share/applications/gprs-data-usage.desktop"
  
  #data_path = "/home/user/.GPRS-Data-Usage"
  
  graph_filename = ""
  pixmap = None
  
  
  showHomeNetwork = True
  useautoreset = False
  resetday = 1
  usedifference = False
  difference = 500
  
  
  config_gprs_home_rx_bytes = 0
  config_gprs_home_tx_bytes = 0
  config_gprs_roaming_rx_bytes = 0
  config_gprs_roaming_tx_bytes = 0
  
  
  
  gconf_gprs_home_rx_bytes = "/cellui/settings/datacounter/transfer/gprs_home_rx_bytes"
  gconf_gprs_home_tx_bytes = "/cellui/settings/datacounter/transfer/gprs_home_tx_bytes"  
  gconf_gprs_home_last_reset = "/cellui/settings/datacounter/general/gprs_home_last_reset" #27.11.2011.1322393597  
  gconf_gprs_home_show_warning = "/cellui/settings/datacounter/general/gprs_home_notification_period" # 0 => disabled,   value > 0 in bytes => enabled
  gconf_gprs_home_warning_limit = "/cellui/settings/datacounter/general/gprs_home_notification_period_UI"
    
  gconf_gprs_roaming_rx_bytes = "/cellui/settings/datacounter/transfer/gprs_roaming_rx_bytes"
  gconf_gprs_roaming_tx_bytes = "/cellui/settings/datacounter/transfer/gprs_roaming_tx_bytes"
  gconf_gprs_roaming_last_reset = "/cellui/settings/datacounter/general/gprs_roaming_last_reset"
  gconf_gprs_roaming_show_warning = "/cellui/settings/datacounter/general/gprs_roaming_notification_period" # 0 => disabled,   value > 0 in bytes => enabled
  gconf_gprs_roaming_warning_limit = "/cellui/settings/datacounter/general/gprs_roaming_notification_period_UI"
  
  version = "?"
  bild = "?"
  
  
  

################################################################################################  
  
  
  
  
class GConfWrapper:
  def __init__(self):
      self.client = gconf.client_get_default()

      
  def get_string(self, key):
      return self.client.get_string(key)

  def set_string(self, key, val):
      self.client.set_string(key, str(val))
      
      
  def get_int(self, key):
      return self.client.get_string(key)

  def set_int(self, key, val):
      self.client.set_int(key, int(val))
      
      
  def get_bool(self, key):
      return self.client.get_bool(key)

  def set_bool(self, key, val):
      self.client.set_bool(key, int(val))

        
        

####################################################################################################


def formatdate(text):
    try:
	data = string.split(text, ".")
	if(int(data[0]) < 10): data[0] = "0" + str(data[0])
	if(int(data[1]) < 10): data[1] = "0" + str(data[1])
	return data[0] + "." + data[1] + "." + data[2]
    except:
	return text

    
    
    
####################################################################################################

class QML_to_Python_Interface(QObject):
    @Slot(bool, bool, int, bool, int)
    def getQMLData(self, showHome, useautoreset, resetday, usedifference, difference):
	print "getQMLData:", showHome, useautoreset, resetday, usedifference, difference
	data.showHomeNetwork = showHome
	data.useautoreset = useautoreset
	data.resetday = resetday
	data.usedifference = usedifference
	data.difference = difference
    
    
    
    @Slot(int, int)
    def getHomeData(self, homeupload, homedownload):			   
	#now = str(int(time.strftime("%d"))) + "." + str(int(time.strftime("%m"))) + time.strftime(".%Y")
	#timestamp = str(int(time.time()))
	#print now + "." + timestamp
	#gconf_client.set_string(data.gconf_gprs_home_last_reset, now + "." + timestamp)
	    
	#if(reset == True):
	now = str(int(time.strftime("%d"))) + "." + str(int(time.strftime("%m"))) + time.strftime(".%Y")
	timestamp = str(int(time.time()))
	print now + "." + timestamp, homeupload, homedownload
	gconf_client.set_string(data.gconf_gprs_home_last_reset, now + "." + timestamp)
	gconf_client.set_string(data.gconf_gprs_home_tx_bytes, str(homeupload * 1000000))
	gconf_client.set_string(data.gconf_gprs_home_rx_bytes, str(homedownload * 1000000))
	
	root.setHomeData(homeupload, homedownload, formatdate(now))
	
	
	
    @Slot(int, int)
    def getRoamingData(self, roamingpload, roamingdownload):		
	#now = str(int(time.strftime("%d"))) + "." + str(int(time.strftime("%m"))) + time.strftime(".%Y")
	#timestamp = str(int(time.time()))
	#print now + "." + timestamp
	#gconf_client.set_string(data.gconf_gprs_roaming_last_reset, now + "." + timestamp)
	#root.setRoamingData(0, 0, now)	
	
	#if(reset == True):
	now = str(int(time.strftime("%d"))) + "." + str(int(time.strftime("%m"))) + time.strftime(".%Y")
	timestamp = str(int(time.time()))
	print now + "." + timestamp, roamingpload, roamingdownload
	gconf_client.set_string(data.gconf_gprs_roaming_last_reset, now + "." + timestamp)
	gconf_client.set_string(data.gconf_gprs_roaming_tx_bytes, str(roamingpload * 1000000))
	gconf_client.set_string(data.gconf_gprs_roaming_rx_bytes, str(roamingdownload * 1000000))
	
	root.setRoamingData(roamingpload, roamingdownload, formatdate(now))
	
	
    @Slot(result=str) #needed, so a QML opject can send a signal
    def get_version(self):
      return str(data.version) + "." + str(data.build)
    
	
	
################################################################################################  


    
    
    

if __name__ == '__main__':
    app = QApplication(sys.argv)

    data = Data()
        
    
    if(platform.machine().startswith('arm')):
      data.root = "/opt/gprs-data-usage/"
    else:
      data.root = "./"
      
    #data.root = "./" #testing

    
    config = Configuration()
    config.Load()
	
    
    gconf_client = GConfWrapper()    
    
     
    view = QDeclarativeView()
    view.setSource(QUrl.fromLocalFile(data.root + 'qml/main.qml'))
    root = view.rootObject()
    
	
	
    #Load version file
    try:
	file = open(data.root + "version", 'r')
	data.version = file.readline()
	data.version=data.version[:-1]
	data.build = file.readline()
	print "Version: "+str(data.version)+ "-"+str(data.build)
    except:
	print "Version file not found, please check your installation!"
    
    #gconf_client.set_string(data.gconf_gprs_home_rx_bytes, str(2000000)) #testing
    #gconf_client.set_string(data.gconf_gprs_home_tx_bytes, str(120000000)) #testing
    #gconf_client.set_string(data.gconf_gprs_roaming_rx_bytes, str(5000000)) #testing
    #gconf_client.set_string(data.gconf_gprs_roaming_tx_bytes, str(780000000)) #testing

    #data.showHomeNetwork = False

    try:
	v = gconf_client.get_string(data.gconf_gprs_home_rx_bytes)
	if(v == None): v = 0
	gprs_home_rx_bytes = int(v) / 1000000

	v = gconf_client.get_string(data.gconf_gprs_home_tx_bytes)
	if(v == None): v = 0
	gprs_home_tx_bytes = int(v) / 1000000

	gprs_home_last_reset = gconf_client.get_string(data.gconf_gprs_home_last_reset)
	if(gprs_home_last_reset == "qtn_cell_counters_never"): gprs_home_last_reset = "?"
	else: gprs_home_last_reset = gprs_home_last_reset[:-11]
	
	gprs_home_show_warning = int(gconf_client.get_string(data.gconf_gprs_home_show_warning))
	if(gprs_home_show_warning > 0): gprs_home_show_warning = True
	else: gprs_home_show_warning = False
	gprs_home_warning_limit = int(gconf_client.get_string(data.gconf_gprs_home_warning_limit))


	v = gconf_client.get_string(data.gconf_gprs_roaming_rx_bytes)
	if(v == None): v = 0
	gprs_roaming_rx_bytes = int(v) / 1000000

	v = gconf_client.get_string(data.gconf_gprs_roaming_tx_bytes)
	if(v == None): v = 0
	gprs_roaming_tx_bytes = int(v) / 1000000

	gprs_roaming_last_reset = gconf_client.get_string(data.gconf_gprs_roaming_last_reset)
	if(gprs_roaming_last_reset == "qtn_cell_counters_never"): gprs_roaming_last_reset = "?"
	else: gprs_roaming_last_reset = gprs_roaming_last_reset[:-11]
	
    except:
	gprs_home_rx_bytes = 0
	gprs_home_tx_bytes = 0
	gprs_home_last_reset = "?"
	gprs_home_show_warning = False
	gprs_home_warning_limit = 0
	
	gprs_roaming_rx_bytes = 0
	gprs_roaming_tx_bytes = 0
	gprs_roaming_last_reset = "?"
	
	print "Failed to fetch gconf data"  
	  
    
    print "Home TX:", gprs_home_tx_bytes, "MB (", data.config_gprs_home_tx_bytes, ")"
    print "Home RX:", gprs_home_rx_bytes, "MB (", data.config_gprs_home_rx_bytes, ")"
    print "Last reset:", gprs_home_last_reset    
    print "Alarm:", gprs_home_show_warning, gprs_home_warning_limit
    
    print "Roaming TX:", gprs_roaming_tx_bytes, "MB (", data.config_gprs_roaming_tx_bytes, ")"
    print "Roaming RX:", gprs_roaming_rx_bytes, "MB (", data.config_gprs_roaming_rx_bytes, ")"
    print "Last reset:", gprs_roaming_last_reset
    
    print "Reset day:", data.resetday
    
    root.setQMLData(data.showHomeNetwork, data.useautoreset, data.resetday, data.usedifference, data.difference)

    root.setHomeData(gprs_home_tx_bytes, gprs_home_rx_bytes, formatdate(gprs_home_last_reset))
    root.setRoamingData(gprs_roaming_tx_bytes, gprs_roaming_rx_bytes, formatdate(gprs_roaming_last_reset))

        
        

    #Those lines has to be run AFTER the above root.-commands, else the dummy values in QML will overwrite our real values!
    # instantiate the Python object
    qml_to_python = QML_to_Python_Interface()
    # expose the object to QML
    context = view.rootContext()
    context.setContextProperty("qml_to_python", qml_to_python)
    
    
    if(platform.machine().startswith('arm')): view.showFullScreen()
    view.show()
           
        
    
    app.exec_() #endless loop
        

    config.Write()
    
    print "Settings done, closing"
    
    
    print "Updating icon"
    os.system("python " + data.root + "update.py --force-update")
    
    
