#!/usr/bin/python

##############################################################################################
# Copyright (c) by George Ruinelli 
# License: 	GPL3
##############################################################################################


import sys
#from PySide.QtCore import *
#from PySide.QtGui import *
#from PySide.QtDeclarative import *
from PySide.QtGui import QDesktopServices as QDS

#import math
import platform
import time
import datetime
import os
import string
import ConfigParser
import gconf
import calendar

print ""

#def debug(text):
  #os.system("echo '" + text + "' >> /tmp/gprs-data-usage.log")


#debug("gprs-data-usage: starting")
  

####################################################################################################
class Configuration():
    def __init__(self):
	#data.config_path = os.path.join(QDS.storageLocation(QDS.DataLocation), "gprs-data-usage")
	data.config_path = "/home/user/.local/share/data/gprs-data-usage/"
	data.config_file = data.config_path + "/" + data.config_file
  
	  
    def Load(self):
	print "Loading configuration from:", data.config_file
	#debug("Loading configuration from: " + data.config_file)
	self.ConfigParser = ConfigParser.SafeConfigParser()
	try:
	    self.ConfigParser.read(data.config_file)
	except: #use default config
	    print "Configuration file "+ data.config_file + " not existing or not compatible"

	try:
	    self.ConfigParser.add_section('main')
	except:
	    pass

	try:	    
	  data.config_gprs_home_rx_bytes = self.ConfigParser.getint("main", "gprs_home_rx_bytes")  
	  data.config_gprs_home_tx_bytes = self.ConfigParser.getint("main", "gprs_home_tx_bytes") 
	  data.config_gprs_roaming_rx_bytes = self.ConfigParser.getint("main", "gprs_roaming_rx_bytes")  
	  data.config_gprs_roaming_tx_bytes = self.ConfigParser.getint("main", "gprs_roaming_tx_bytes")  
	  data.showHomeNetwork = self.ConfigParser.getboolean("main", "showHomeNetwork")  
	except:
	  print "Error loading configuration 1, using default value"
	  
	try:
	  data.useautoreset = self.ConfigParser.getboolean("main", "useautoreset")  
	  data.resetday = self.ConfigParser.getint("main", "resetday")  
	  data.usedifference = self.ConfigParser.getboolean("main", "usedifference")  
	  data.difference = self.ConfigParser.getint("main", "difference")  
	  print "Configuration loaded"  
	  #debug("Configuration loaded")
	except:
	  print "Error loading configuration 2, using default value"

  

	
    
    
    
    
    
    def Write(self):
	print "Write configuration to:", data.config_file  
	
	#self.ConfigParser.add_section('main')
		  
	self.ConfigParser.set('main', 'gprs_home_rx_bytes', str(data.config_gprs_home_rx_bytes))
	self.ConfigParser.set('main', 'gprs_home_tx_bytes', str(data.config_gprs_home_tx_bytes))
	self.ConfigParser.set('main', 'gprs_roaming_rx_bytes', str(data.config_gprs_roaming_rx_bytes))
	self.ConfigParser.set('main', 'gprs_roaming_tx_bytes', str(data.config_gprs_roaming_tx_bytes))
	self.ConfigParser.set('main', 'showHomeNetwork', str(data.showHomeNetwork))
	self.ConfigParser.set('main', 'useautoreset', str(data.useautoreset))
	self.ConfigParser.set('main', 'resetday', str(data.resetday))
	self.ConfigParser.set('main', 'usedifference', str(data.usedifference))
	self.ConfigParser.set('main', 'difference', str(data.difference))

	try:
	    os.makedirs(data.config_path)
	except:
	  pass

	try:
	    handle = open(data.config_file, 'w')
	    self.ConfigParser.write(handle)
	    handle.close()
	    print "Configuration saved"
	except:
	    print "Failed to write configuration file!"


	    
################################################################################################  



class Data():
    
  config_path = ""
  config_file = "config.conf"
  
  desktop_file = "/home/user/.local/share/applications/gprs-data-usage.desktop"
  #icon_template = "/home/user/MyDocs/GPRS-Data-Usage/images/icon.svg"
  icon_template = "/opt/gprs-data-usage/images/icon.svg"
  icon_file = "/home/user/.local/share/data/gprs-data-usage/icon.svg"
  
  
  
  #graph_filename = ""
  #pixmap = None
  
  

  showHomeNetwork = True
  useautoreset = False
  resetday = 1
  usedifference = False
  difference = 500
  
  
  config_gprs_home_rx_bytes = 0
  config_gprs_home_tx_bytes = 0
  config_gprs_roaming_rx_bytes = 0
  config_gprs_roaming_tx_bytes = 0
  
  
  
  gconf_gprs_home_rx_bytes = "/cellui/settings/datacounter/transfer/gprs_home_rx_bytes"
  gconf_gprs_home_tx_bytes = "/cellui/settings/datacounter/transfer/gprs_home_tx_bytes"  
  gconf_gprs_home_last_reset = "/cellui/settings/datacounter/general/gprs_home_last_reset" #27.11.2011.1322393597
    
  gconf_gprs_roaming_rx_bytes = "/cellui/settings/datacounter/transfer/gprs_roaming_rx_bytes"
  gconf_gprs_roaming_tx_bytes = "/cellui/settings/datacounter/transfer/gprs_roaming_tx_bytes"
  gconf_gprs_roaming_last_reset = "/cellui/settings/datacounter/general/gprs_roaming_last_reset"
  

################################################################################################  
  
  
  
  
class GConfWrapper:
  def __init__(self):
      self.client = gconf.client_get_default()

      
  def get_string(self, key):
      return self.client.get_string(key)

  def set_string(self, key, val):
      self.client.set_string(key, str(val))
      
      
  def get_int(self, key):
      return self.client.get_string(key)

  def set_int(self, key, val):
      self.client.set_int(key, int(val))
      
      
  def get_bool(self, key):
      return self.client.get_bool(key)

  def set_bool(self, key, val):
      self.client.set_bool(key, int(val))

        
        

################################################################################################  




def formatdate(text):
    try:
	data = string.split(text, ".")
	if(int(data[0]) < 10): data[0] = "0" + str(data[0])
	if(int(data[1]) < 10): data[1] = "0" + str(data[1])
	return data[0] + "." + data[1] + "." + data[2]
    except:
	return text


    

################################################################################################  



    
data = Data()


config = Configuration()
config.Load()
    
gconf_client = GConfWrapper()    



try:
    v = gconf_client.get_string(data.gconf_gprs_home_rx_bytes)
    if(v == None): v = 0
    gprs_home_rx_bytes = int(v) / 1000000

    v = gconf_client.get_string(data.gconf_gprs_home_tx_bytes)
    if(v == None): v = 0
    gprs_home_tx_bytes = int(v) / 1000000

    gprs_home_last_reset = gconf_client.get_string(data.gconf_gprs_home_last_reset)
    if(gprs_home_last_reset == "qtn_cell_counters_never"): gprs_home_last_reset = "?"
    else: gprs_home_last_reset = gprs_home_last_reset[:-11]


    v = gconf_client.get_string(data.gconf_gprs_roaming_rx_bytes)
    if(v == None): v = 0
    gprs_roaming_rx_bytes = int(v) / 1000000

    v = gconf_client.get_string(data.gconf_gprs_roaming_tx_bytes)
    if(v == None): v = 0
    gprs_roaming_tx_bytes = int(v) / 1000000

    gprs_roaming_last_reset = gconf_client.get_string(data.gconf_gprs_roaming_last_reset)
    if(gprs_roaming_last_reset == "qtn_cell_counters_never"): gprs_roaming_last_reset = "?"
    else: gprs_roaming_last_reset = gprs_roaming_last_reset[:-11]

except:
    gprs_home_rx_bytes = 0
    gprs_home_tx_bytes = 0
    gprs_home_last_reset = "?"
    gprs_roaming_rx_bytes = 0
    gprs_roaming_tx_bytes = 0
    gprs_roaming_last_reset = "?"
    print "Failed to fetch gconf data"
      

print "Home TX:", gprs_home_tx_bytes, "MB (", data.config_gprs_home_tx_bytes, ")"
#debug("Home TX: " + str(gprs_home_tx_bytes) + ", " + str(data.config_gprs_home_tx_bytes))
print "Home RX:", gprs_home_rx_bytes, "MB (", data.config_gprs_home_rx_bytes, ")"
#debug("Home RX: " + str(gprs_home_rx_bytes) + ", " + str(data.config_gprs_home_rx_bytes))
print "Last reset:", gprs_home_last_reset

print "Roaming TX:", gprs_roaming_tx_bytes, "MB (", data.config_gprs_roaming_tx_bytes, ")"
#debug("Roaming TX: " + str(gprs_roaming_tx_bytes) + ", " + str(data.config_gprs_roaming_tx_bytes))
print "Roaming RX:", gprs_roaming_rx_bytes, "MB (", data.config_gprs_roaming_rx_bytes, ")"
#debug("Roaming RX: " + str(gprs_roaming_rx_bytes) + ", " + str(data.config_gprs_roaming_rx_bytes))
print "Last reset:", gprs_roaming_last_reset



update = False

if(len(sys.argv) > 1): #there is at least 1 command line parameter
    print "Command line parameters:", sys.argv[1:]
    if(sys.argv[1] == "--force-update"):
	print "Force update"
	update = True



if(data.useautoreset == True):
    #day = str(int(time.strftime("%d")))
    year = int(time.strftime("%Y"))
    month = int(time.strftime("%m"))
    day = int(time.strftime("%d"))
    #print "Day:", day
    print "Now:", day, month, year
    
    daysinthismonth = calendar.monthrange(year, month)[1]
    #print daysinthismonth
    if(daysinthismonth < data.resetday): #if this month has not as many days as set in reset day, set it to last day of the month
	resetday = daysinthismonth
    else:
	resetday = data.resetday
    print "Day of reseting:", resetday

    if(data.showHomeNetwork): #home
	r = gprs_home_last_reset
    else: #roaming
	r = gprs_roaming_last_reset
	
	
    r = string.split(r, ".")
    try:
	last_reset_month = int(r[1])
    except:
	last_reset_month = 0
    print "Last Reset Month:", last_reset_month


    if(month != last_reset_month): #reset
	if(day == resetday):
	    print "Reset"
	    now = str(int(time.strftime("%d"))) + "." + str(int(time.strftime("%m"))) + time.strftime(".%Y")
	    timestamp = str(int(time.time()))
	    print now + "." + timestamp
	    
	    #if(data.showHomeNetwork): #home
	    gconf_client.set_string(data.gconf_gprs_home_tx_bytes, "0")
	    gconf_client.set_string(data.gconf_gprs_home_rx_bytes, "0")
	    gconf_client.set_string(data.gconf_gprs_home_last_reset, now + "." + timestamp)
	    #else: #roaming
	    gconf_client.set_string(data.gconf_gprs_roaming_tx_bytes, "0")
	    gconf_client.set_string(data.gconf_gprs_roaming_rx_bytes, "0")
	    gconf_client.set_string(data.gconf_gprs_roaming_last_reset, now + "." + timestamp)
	    
	    gprs_home_rx_bytes = 0
	    gprs_home_tx_bytes = 0
	    gprs_roaming_tx_bytes = 0
	    gprs_roaming_tx_bytes = 0
	    gprs_home_last_reset = now
	    gprs_roaming_last_reset = now
	    
	    update = True #force icon refresh
	else:
	    print "Today is not reset day"
    else:
	print "Already reset in this month"










if(data.showHomeNetwork):
    if(data.config_gprs_home_rx_bytes != gprs_home_rx_bytes or data.config_gprs_home_tx_bytes != gprs_home_tx_bytes): update = True
else:
    if(data.config_gprs_roaming_rx_bytes != gprs_roaming_rx_bytes or data.config_gprs_roaming_tx_bytes != gprs_roaming_tx_bytes): update = True

#update = True #didnt update always, so force it every time

if(update == False):
    print "Data still equal, do not re-create icon"
else:
    print "Data changed, re-create icon" 
    
    ##### store new values in config ##########
    data.config_gprs_home_rx_bytes = gprs_home_rx_bytes
    data.config_gprs_home_tx_bytes = gprs_home_tx_bytes
    data.config_gprs_roaming_rx_bytes = gprs_roaming_rx_bytes
    data.config_gprs_roaming_tx_bytes = gprs_roaming_tx_bytes
    config.Write()
    
    
    if(data.showHomeNetwork):
      rx = gprs_home_rx_bytes	  
      tx = gprs_home_tx_bytes
      since = formatdate(gprs_home_last_reset)
    else:
      rx = gprs_roaming_rx_bytes	  
      tx = gprs_roaming_tx_bytes
      since = formatdate(gprs_roaming_last_reset)
      
      
    total = rx + tx
      
    if(data.usedifference):
      #rx = data.difference - rx
      #tx = data.difference - tx
      total = data.difference - total
      total_title = "Remaining"
    else:
      total_title = "Total"
      
      
      
    print "Data:"
    print "TX:", tx
    print "RX:", rx
    print total_title, total
    
      
      
    
    
    #load icon data
    text = ""
    try:
	file = open(data.icon_template, 'r')
	for line in file:
	  text = text + line + "\n"  
	file.close()
    except:
	print "Could not open file:", data.icon_template
    
    text = string.replace(text, "$UPLOAD$", str(tx) + " MB")
    text = string.replace(text, "$DOWNLOAD$", str(rx) + " MB")   
    text = string.replace(text, "$SUM_TITLE$", total_title)
    text = string.replace(text, "$SUM$", str(total) + " MB") 
    text = string.replace(text, "$SINCE$", "since " + since)
    
    #print text
    
    print "Create new icon:", data.icon_file
    try:
	file = open(data.icon_file, 'w')
	file.write(text)
	file.close()
    except:
	print "Could not open file:", data.icon_file
    
    
      


    ##### touch desktop file so icon gets reloaded ##########
    print "Touch desktop file to update home screen:", data.desktop_file
    os.system("touch " + data.desktop_file)




#app.exec_() #endless loop


print "Update done, closing"

    
    
